ForwardingSortedMap
Date: 2016-05-24

com.google.common.collect

## Class ForwardingSortedMap<K,V>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingMap<K,V>
    - - com.google.common.collect.ForwardingSortedMap<K,V>

- All Implemented Interfaces:
    java.util.Map<K,V>, java.util.SortedMap<K,V>
  Direct Known Subclasses:
    ForwardingNavigableMap

      @GwtCompatible
      public abstract class ForwardingSortedMap<K,V>
      extends ForwardingMap<K,V>
      implements java.util.SortedMap<K,V>

  A sorted map which forwards all its method calls to another sorted map. Subclasses should override one or more methods to modify the behavior of the backing sorted map as desired per the decorator pattern.

  Warning: The methods of `ForwardingSortedMap` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingMap.put(K, V)` alone will not change the behavior of `ForwardingMap.putAll(java.util.Map<? extends K, ? extends V>)`, which can lead to unexpected behavior. In this case, you should override `putAll` as well, either providing your own implementation, or delegating to the provided `standardPutAll` method.

  Each of the `standard` methods, where appropriate, use the comparator of the map to test equality for both keys and values, unlike `ForwardingMap`.

  The `standard` methods and the collection views they return are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

  Since:
    2.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `ForwardingSortedMap.StandardKeySet` A sensible implementation of `SortedMap.keySet()` in terms of the methods of `ForwardingSortedMap`.

    - ### Nested classes/interfaces inherited from class com.google.common.collect.ForwardingMap

      `ForwardingMap.StandardEntrySet, ForwardingMap.StandardValues`

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingSortedMap()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Comparator<? super K>` | `comparator()`
    `protected abstract java.util.SortedMap<K,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `K` | `firstKey()`
    `java.util.SortedMap<K,V>` | `headMap(K toKey)`
    `K` | `lastKey()`
    `protected boolean` | `standardContainsKey(java.lang.Object key)` A sensible definition of `ForwardingMap.containsKey(java.lang.Object)` in terms of the `firstKey()` method of `tailMap(K)`.
    `protected java.util.SortedMap<K,V>` | `standardSubMap(K fromKey, K toKey)` A sensible default implementation of `subMap(Object, Object)` in terms of `headMap(Object)` and `tailMap(Object)`.
    `java.util.SortedMap<K,V>` | `subMap(K fromKey, K toKey)`
    `java.util.SortedMap<K,V>` | `tailMap(K fromKey)`

    - ### Methods inherited from class com.google.common.collect.ForwardingMap

      `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, standardClear, standardContainsValue, standardEquals, standardHashCode, standardIsEmpty, standardPutAll, standardRemove, standardToString, values`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.SortedMap

      `entrySet, keySet, values`

    - ### Methods inherited from interface java.util.Map

      `clear, containsKey, containsValue, equals, get, hashCode, isEmpty, put, putAll, remove, size`

- - ### Constructor Detail

    - #### ForwardingSortedMap

          protected ForwardingSortedMap()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract java.util.SortedMap<K,V> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingMap<K,V>`

    - #### comparator

          public java.util.Comparator<? super K> comparator()

      Specified by:
        `comparator` in interface `java.util.SortedMap<K,V>`

    - #### firstKey

          public K firstKey()

      Specified by:
        `firstKey` in interface `java.util.SortedMap<K,V>`

    - #### headMap

          public java.util.SortedMap<K,V> headMap(K toKey)

      Specified by:
        `headMap` in interface `java.util.SortedMap<K,V>`

    - #### lastKey

          public K lastKey()

      Specified by:
        `lastKey` in interface `java.util.SortedMap<K,V>`

    - #### subMap

          public java.util.SortedMap<K,V> subMap(K fromKey,
                                        K toKey)

      Specified by:
        `subMap` in interface `java.util.SortedMap<K,V>`

    - #### tailMap

          public java.util.SortedMap<K,V> tailMap(K fromKey)

      Specified by:
        `tailMap` in interface `java.util.SortedMap<K,V>`

    - #### standardContainsKey

          @Beta
          protected boolean standardContainsKey(@Nullable
                                         java.lang.Object key)

      A sensible definition of `ForwardingMap.containsKey(java.lang.Object)` in terms of the `firstKey()` method of `tailMap(K)`. If you override `tailMap(K)`, you may wish to override `ForwardingMap.containsKey(java.lang.Object)` to forward to this implementation.
      Overrides:
        `standardContainsKey` in class `ForwardingMap<K,V>`
      Since:
        7.0

    - #### standardSubMap

          @Beta
          protected java.util.SortedMap<K,V> standardSubMap(K fromKey,
                                                     K toKey)

      A sensible default implementation of `subMap(Object, Object)` in terms of `headMap(Object)` and `tailMap(Object)`. In some situations, you may wish to override `subMap(Object, Object)` to forward to this implementation.
      Since:
        7.0